// alfredoarteaga@terra.com.mx
// Prueba de la Clase TGraph
// Alfredo Arteaga
// 20/08/2002

#Include "FiveWin.Ch"
#Include "TGraph.Ch"

Static oWnd, aSerie, nTotal, oBtn[15]
Static aSers, aPers, nGraph, aValues
Static cFile

FUNCTION Main()

   LOCAL oMenu, oFont

   #ifdef __CLIPPER__
      SET RESOURCES TO "Test.Dll"
   #else
      SET RESOURCES TO "Test32.Dll"
   #endif

   MENU oMenu
      MENUITEM "&Opciones"
      MENU
         MENUITEM "&Nuevo grfico" ACTION GraphTest("New")
         MENUITEM "&Abrir archivo" ;
            ACTION IF((cFile:=cGetFile("Grficas|*.TGr","Seleccione archivo"))<>NIL,GraphTest(cFile),)
         SEPARATOR
         MENUITEM "&Salir"         ACTION oWnd:End()
      ENDMENU
      oMenu:AddMdi()
   ENDMENU

   DEFINE FONT oFont NAME "MS Sans Serif" SIZE 0,-10
   DEFINE WINDOW oWnd FROM 1, 1 TO 350, 550 PIXEL MDI TITLE "TGraph 2 (la clase)" MENU oMenu

   SET MESSAGE OF oWnd TO "Grficos con Clipper-FiveWin (sin vbx)" KEYBOARD CLOCK DATE NOINSET
   SET FONT OF oWnd TO oFont

   #ifndef __XPP__
      ACTIVATE WINDOW oWnd MAXIMIZED ON INIT GraphTest()
   #else
      ACTIVATE WINDOW oWnd MAXIMIZED
   #endif

   SET RESOURCES TO
   oFont:End()

RETURN (Nil)

// --- Window test

FUNCTION GraphTest(cFile)

   LOCAL oWndChild, oGraph, oBar, oCbx
   LOCAL aItem, cItem, oPop
   DEFAULT cFile:="New"
   IF Empty(cFile)
      RETURN (NIL)
   ENDIF
   MENU oPop POPUP
      MENUITEM "&Series"   ;
         ACTION (nGraph:=SERIE_VALUES ,Sel_Graph(aItem,aSers,oGraph,oCbx,@cItem,nGraph))
      MENUITEM "&Periodos" ;
         ACTION (nGraph:=PERIOD_VALUES,Sel_Graph(aItem,aPers,oGraph,oCbx,@cItem,nGraph))
   ENDMENU

   DEFINE WINDOW oWndChild MDIChild TITLE "Anlisis de informacin"

   DEFINE BUTTONBAR oBar _3DLOOK BUTTONSIZE 25,25 OF oWndChild
// DEFINE BUTTON oBtn[ 1] OF oBar RESOURCE "Open"    NOBORDER TOOLTIP "Abrir"    ;
//    ACTION LoadGraph("",oGraph,aItem,@cItem,oCbx)
   DEFINE BUTTON oBtn[ 2] OF oBar RESOURCE "Save"    NOBORDER TOOLTIP "Guardar"  ;
      ACTION SaveGraph(oGraph,cItem)
   DEFINE BUTTON oBtn[ 3] OF oBar RESOURCE "Bars"    NOBORDER TOOLTIP "Barras"      GROUP  ;
      ACTION (oGraph:nType:=GRAPH_TYPE_BAR  , Verify_Set(oGraph))
   DEFINE BUTTON oBtn[ 4] OF oBar RESOURCE "Lines"   NOBORDER TOOLTIP "Lneas"   ;
      ACTION (oGraph:nType:=GRAPH_TYPE_LINE , Verify_Set(oGraph))
   DEFINE BUTTON oBtn[ 5] OF oBar RESOURCE "Points"  NOBORDER TOOLTIP "Puntos"   ;
      ACTION (oGraph:nType:=GRAPH_TYPE_POINT, Verify_Set(oGraph))
   DEFINE BUTTON oBtn[ 6] OF oBar RESOURCE "Pie"     NOBORDER TOOLTIP "Torta"    ;
      ACTION (oGraph:nType:=GRAPH_TYPE_PIE, Verify_Set(oGraph,oCbx,aItem,@cItem))
   DEFINE BUTTON oBtn[ 7] OF oBar RESOURCE "3D"      NOBORDER TOOLTIP "Vista en 3D" GROUP  ;
      ACTION (oGraph:l3D  :=!oGraph:l3D     ,oGraph:Refresh())
   DEFINE BUTTON oBtn[ 8] OF oBar RESOURCE "xGrid"   NOBORDER TOOLTIP "Rejilla horizontal" ;
      ACTION (oGraph:lxGrid:=!oGraph:lxGrid ,oGraph:Refresh())
   DEFINE BUTTON oBtn[ 9] OF oBar RESOURCE "yGrid"   NOBORDER TOOLTIP "Rejilla vertical"   ;
      ACTION (oGraph:lyGrid:=!oGraph:lyGrid ,oGraph:Refresh())
   DEFINE BUTTON oBtn[10] OF oBar RESOURCE "Fonts"   NOBORDER TOOLTIP "Tipo de letra"      ;
      ACTION Chg_Fonts(oWndChild, 23,250,oGraph)
   DEFINE BUTTON oBtn[11] OF oBar RESOURCE "Printer" NOBORDER TOOLTIP "Imprimir"    GROUP  ;
      ACTION GetPrtCoors(oGraph)
   DEFINE BUTTON oBtn[12] OF oBar RESOURCE "Copy"    NOBORDER TOOLTIP "Copiar"             ;
      ACTION oGraph:Copy2Clipboard()
   DEFINE BUTTON oBtn[13] OF oBar RESOURCE "Tools"   NOBORDER TOOLTIP "Propiedades..."     ;
      ACTION Chg_Settings(oGraph,oCbx,aItem,@cItem)
   DEFINE BUTTON oBtn[14] OF oBar RESOURCE "Series"  NOBORDER TOOLTIP "Anlisis de..." MENU oPop GROUP
   @  0.25,51 COMBOBOX oCbx VAR cItem ITEMS aItem OF oBar SIZE 125,200;
      ON CHANGE View_Graph(oCbx,oGraph) FONT oWnd:oFont

   oGraph:=TGraph():New(0,0,oWndChild,oWndChild:nWidth(),oWndChild:nHeight())

   IF cFile="New"
      nGraph:=SERIE_VALUES
      aItem:={"Serie"}
      aPers:={"Uno"}
      cItem:= "Serie"
      aSers:=aItem
      oGraph:cTitle := "NUEVO GRAFICO"
      oGraph:cSubTit:= "Vaya a propiedades e indique los valores correspondientes"
      oGraph:cTitX  := "Valores"
      oGraph:cTitY  := "Etiquetas"
      oGraph:lPopUp := .T.
      oGraph:AddSerie({ 0 }, "Serie", RGB(128,128,255))
      oGraph:SetYVals(aPers)
   ELSE
      LoadGraph(cFile,oGraph,aItem,@cItem,oCbx)
   ENDIF

   oBar:bRClicked:={|| MsgInfo(" Que intentas ?...")}
   oWndChild:SetControl(oGraph)
   oWndChild:SetText(cFile)

   // ACTIVATE WINDOW oWndChild


RETURN (Nil)

FUNCTION View_Graph(oCbx,oGraph)    // Muestra serie o periodo
   LOCAL nPos:=Max(oCbx:nAt,1)
   IF nGraph=SERIE_VALUES
      oGraph:SelSerie(IF(nPos>1,nPos-1,.T.))
   ELSE
      oGraph:SelPeriod(nPos)
   ENDIF
   oGraph:Refresh()
RETURN (Nil)

FUNCTION Sel_Graph(aItem,aVals,oGraph,oCbx,cItem)
   aItem:=aVals
   IF Len(aItem)>0
      oCbx:SetItems(aItem)
      oCbx:Select(1)
      cItem:=aItem[1]
      IF nGraph=SERIE_VALUES
         IF oGraph:nType=GRAPH_TYPE_PIE .AND. Len(aItem)>1
            oCbx:Select(2)
            cItem:=aItem[2]
         ELSE
            oGraph:SelSerie(.T.)
         ENDIF
      ELSE
         oGraph:SelPeriod(1)
      ENDIF
      Verify_Set(oGraph)
   ENDIF
RETURN (Nil)

FUNCTION Verify_Set(oGraph,oCbx,aItem,cItem)
   DEFAULT oCbx:=Nil
   oBtn[ 4]:Enable()
   oBtn[ 8]:Enable()
   oBtn[ 9]:Enable()
   IF nGraph=PERIOD_VALUES .OR. Len(oGraph:aData[1])=1
      oBtn[4]:Disable()
      IF oGraph:nType=GRAPH_TYPE_LINE
         oGraph:nType:=GRAPH_TYPE_PIE
      ENDIF
   ENDIF
   IF oGraph:nType=GRAPH_TYPE_PIE
      oBtn[ 8]:Disable()
      oBtn[ 9]:Disable()
      IF nGraph=SERIE_VALUES
         IF oCbx!=Nil .AND. oCbx:nAt=1
            oCbx:SetItems(aItem)
            IF Len(aItem)>1
               oCbx:Select(2)
               cItem:=aItem[2]
            ELSE
               oCbx:Select(1)
               cItem:=aItem[1]
            ENDIF
            oCbx:Refresh()
            View_Graph(oCbx,oGraph)
         ENDIF
      ENDIF
   ENDIF
   oBtn[ 4]:Refresh()
   oBtn[ 8]:Refresh()
   oBtn[ 9]:Refresh()
   oGraph:Refresh()
RETURN (Nil)

// Cambio de caractersticas o propiedades del grfico ----------------------

FUNCTION Chg_Settings(oGraph,oCbx,aItem,cItem)

   LOCAL oDlg, aSet[25], cSerie, oBak, oGrd, nLen
   LOCAL lUpdate:=.F., oTyp, cType, nType, aType
   LOCAL oLbx, hBmp, aSerT, aDatT, aPerT , nLSer
   LOCAL oPnt, cPoint, aPoint, nI, oSer, oB[6]
   LOCAL aSerL:=aGetSeries(oGraph)

   aSerT:=AClone(oGraph:aSTemp)
   aPerT:=AClone(oGraph:aYTemp)
   aDatT:=AClone(oGraph:aDTemp)
   nLSer:=Len(aSerT)

   hBmp   := LoadBitMap(GetResources(),"C_Ind")
   aType  := {"Barras","Lneas","Puntos","Torta","Mezcla"}
   aPoint := {"Punto","Cruz","Rombo"}
   cPoint := aPoint[oGraph:nPoint]
   nType  := oGraph:nType
   cType  := aType[nType]
   aValues:= {}
   cSerie := aSerL[1]

   aSet[ 1] := oGraph:l3D
   aSet[ 2] := oGraph:lTitle
   aSet[ 3] := oGraph:lxVal
   aSet[ 4] := oGraph:lyVal
   aSet[ 5] := oGraph:lLegends
   aSet[ 6] := oGraph:lViewVal
   aSet[ 7] := oGraph:lxGrid
   aSet[ 8] := oGraph:lyGrid
   aSet[ 9] := oGraph:lBorders
   aSet[10] := oGraph:nBarD
   aSet[11] := oGraph:nXRanges
   aSet[12] := Space(10-Len(oGraph:cPicture))+oGraph:cPicture
   aSet[13] := oGraph:cTitle +Space(50-Len(oGraph:cTitle ))
   aSet[14] := oGraph:cSubTit+Space(50-Len(oGraph:cSubTit))
   aSet[15] := oGraph:cTitX  +Space(50-Len(oGraph:cTitX  ))
   aSet[16] := oGraph:cTitY  +Space(50-Len(oGraph:cTitY  ))
   aSet[17] := oGraph:aSTitle[1]
   aSet[18] := oGraph:aSTitle[2]
   aSet[19] := oGraph:aSTitle[3]
   aSet[20] := oGraph:aSTitle[4]
   aSet[21] := oGraph:lcTitle
   aSet[22] := oGraph:nClrBack
   aSet[23] := oGraph:nClrGrid
   aSet[24] := oGraph:nBarSep
   aSet[25] := oGraph:nClrPane

   DEFINE DIALOG oDlg RESOURCE "Settings" FONT oWnd:oFont
   REDEFINE CHECKBOX aSet[ 1] ID 101 OF oDlg
   REDEFINE CHECKBOX aSet[ 2] ID 102 OF oDlg
   REDEFINE CHECKBOX aSet[ 3] ID 103 OF oDlg
   REDEFINE CHECKBOX aSet[ 4] ID 104 OF oDlg
   REDEFINE CHECKBOX aSet[ 5] ID 105 OF oDlg
   REDEFINE CHECKBOX aSet[ 6] ID 106 OF oDlg
   REDEFINE CHECKBOX aSet[ 7] ID 107 OF oDlg
   REDEFINE CHECKBOX aSet[ 8] ID 108 OF oDlg
   REDEFINE CHECKBOX aSet[ 9] ID 109 OF oDlg
   REDEFINE COMBOBOX oTyp VAR cType  ITEMS aType ID 111 OF oDlg
   REDEFINE COMBOBOX oPnt VAR cPoint ITEMS aPoint ID 113 OF oDlg  ;
      ON CHANGE (oGraph:nPoint:=oPnt:nAt,oGraph:Refresh(.T.))     ;
      BITMAPS {"Point","Cross","Shape"}
   REDEFINE BTNBMP oB[1] ID 131 OF oDlg TOOLTIP "Seleccionar..."   ;
      ACTION aSet[25]:=SelColors(oB[1],aSet[25])
   REDEFINE BTNBMP oB[2] ID 132 OF oDlg TOOLTIP "Seleccionar..."   ;
      ACTION aSet[22]:=SelColors(oB[2],aSet[22])
   REDEFINE BTNBMP oB[3] ID 133 OF oDlg TOOLTIP "Seleccionar..."   ;
      ACTION aSet[23]:=SelColors(oB[3],aSet[23])
   REDEFINE GET aSet[24] ID 115 OF oDlg PICTURE "99" SPINNER MIN  0 MAX  5
   REDEFINE GET aSet[10] ID 116 OF oDlg PICTURE "99" SPINNER MIN  1 MAX 50
   REDEFINE GET aSet[11] ID 117 OF oDlg PICTURE "99" SPINNER MIN  1 MAX 10
   REDEFINE GET aSet[12] ID 118 OF oDlg PICTURE "@X"
   REDEFINE BITMAP ID 120 OF oDlg RESOURCE "Graph" ON CLICK MsgInfo("Que intentas?...")
   REDEFINE GET aSet[13] ID 121 OF oDlg PICTURE "@X"
   REDEFINE GET aSet[14] ID 122 OF oDlg PICTURE "@X"
   REDEFINE GET aSet[15] ID 123 OF oDlg PICTURE "@X"
   REDEFINE GET aSet[16] ID 124 OF oDlg PICTURE "@X"
   REDEFINE CHECKBOX aSet[17] ID 125 OF oDlg
   REDEFINE CHECKBOX aSet[18] ID 126 OF oDlg
   REDEFINE CHECKBOX aSet[19] ID 127 OF oDlg
   REDEFINE CHECKBOX aSet[20] ID 128 OF oDlg
   REDEFINE CHECKBOX aSet[21] ID 129 OF oDlg
   REDEFINE BTNBMP ID 301 OF oDlg RESOURCE "New"    TOOLTIP "Agregar serie"        NOBORDER ;
      ACTION GetName(oLbx,oSer,@cSerie,aSerL,.T.,aSerT,aPerT,aDatT)
   REDEFINE BTNBMP ID 302 OF oDlg RESOURCE "Delete" TOOLTIP "Borrar serie"         NOBORDER ;
      ACTION DelSerie(oSer,@cSerie,aSerL,aSerT,aPerT,aDatT)
   REDEFINE BTNBMP ID 303 OF oDlg RESOURCE "Open"   TOOLTIP "Cambiar propiedades"  NOBORDER ;
      ACTION GetName(oLbx,oSer,@cSerie,aSerL,.F.,aSerT,aPerT,aDatT)
   REDEFINE COMBOBOX oSer VAR cSerie ITEMS aSerL ID 310 OF oDlg ;
      ON CHANGE GetValues(oLbx,oSer,aSerT,aDatT,aPerT)
   REDEFINE BTNBMP oB[4] ID 311 OF oDlg RESOURCE "New"    TOOLTIP "Agregar periodo" NOBORDER ;
      ACTION NewPeriod(oLbx,oB,oSer:nAt,aSerT,aDatT,aPerT)
   REDEFINE BTNBMP oB[5] ID 312 OF oDlg RESOURCE "Delete" TOOLTIP "Borrar periodo"  NOBORDER ;
      ACTION DelPeriod(oLbx,oSer:nAt,aSerT,aDatT,aPerT)
   REDEFINE BTNBMP oB[6] ID 313 OF oDlg RESOURCE "Open"   TOOLTIP "Cambiar valores" NOBORDER ;
      ACTION ChgPeriod(oLbx,oB,oSer:nAt,aSerT,aDatT,aPerT)

   REDEFINE LISTBOX oLbx FIELDS "" ;   // de Hernan Diego Cesareli
      HEADER "", "Periodo", "Valor" ID 320 OF oDlg  SIZES 15,80,60
      oLbx:cAlias    := "Array"
      oLbx:SetArray( aValues )
      oLbx:nAt       := 1
      oLbx:lAutoEdit := .T.
      oLbx:lAutoSkip := .T.
      oLbx:lCellStyle:= .T.
      oLbx:nColAct   := 2
      oLbx:lDrawFooter :=.T.
      oLbx:nClrFFore   :=CLR_BLUE
      oLbx:nClrForeHead:=CLR_BLUE
      oLbx:aJustify  := { 2, 0, 1 }
      oLbx:aFJustify := { 0, 1, 1 }
      oLbx:bGoTop    := { || oLbx:nAt := 1 }
      oLbx:bGoBottom := { || oLbx:nAt := Eval( oLbx:bLogicLen ) }
      oLbx:bSkip     := { | nWant, nOld | nOld := oLbx:nAt, oLbx:nAt += nWant,;
                            oLbx:nAt := Max( 1, Min( oLbx:nAt, Eval( oLbx:bLogicLen ) ) ),;
                            oLbx:nAt - nOld }
      oLbx:bLine:= { |nAt| nAt:= oLbx:nAt,                       ;
                          IF( Len(aValues)<1 .OR. nAt>Len(aValues),;
                              Array(3),                          ;
                             { IF( oLbx!=Nil .AND. oLbx:lSelect, hBmp, 0 ),;
                               aValues[nAt,1],                    ;
                               Transform( aValues[nAt,2], "9999,999.99" ) } ) }
      oLbx:bLogicLen := { || Len( aValues ) }
      oLbx:aFooters  := { || { "", "Total ", Tran(nTotal,"9999,999.99" ) } }
      oLbx:bKeyDown  := { |nKey| ValnKey(nKey,oLbx,oB,oSer:nAt,aSerT,aDatT,aPerT)}
      oLbx:bEdit     := { | nCol, cBuffer, lFirst |;
                            EditValue( oLbx, nCol, cBuffer, aValues, lFirst, @nTotal) }

   REDEFINE BUTTON ID 130 OF oDlg ACTION (lUpdate:=.T., oDlg:End())
   REDEFINE BUTTON ID 140 OF oDlg ACTION oDlg:End() CANCEL
   oB[1]:nClrPane:=oGraph:nClrPane
   oB[2]:nClrPane:=oGraph:nClrBack
   oB[3]:nClrPane:=oGraph:nClrGrid
   ACTIVATE DIALOG oDlg CENTERED;
      ON INIT GetValues(oLbx,oSer,aSerT,aDatT,aPerT)

   IF lUpdate

      oGraph:l3D     := aSet[ 1]
      oGraph:lTitle  := aSet[ 2]
      oGraph:lxVal   := aSet[ 3]
      oGraph:lyVal   := aSet[ 4]
      oGraph:lLegends:= aSet[ 5]
      oGraph:lViewVal:= aSet[ 6]
      oGraph:lxGrid  := aSet[ 7]
      oGraph:lyGrid  := aSet[ 8]
      oGraph:lBorders:= aSet[ 9]
      oGraph:nBarD   := aSet[10]
      oGraph:nXRanges:= aSet[11]
      oGraph:cPicture:= Alltrim(aSet[12])
      oGraph:cTitle  := Alltrim(aSet[13])
      oGraph:cSubTit := Alltrim(aSet[14])
      oGraph:cTitX   := Alltrim(aSet[15])
      oGraph:cTitY   := Alltrim(aSet[16])
      oGraph:nType   := oTyp:nAt
      oGraph:aSTitle := { aSet[17], aSet[18], aSet[19], aSet[20] }
      oGraph:lcTitle := aSet[21]
      oGraph:nClrBack:= aSet[22]
      oGraph:nClrGrid:= aSet[23]
      oGraph:nBarSep := aSet[24]
      oGraph:nClrPane:= aSet[25]

      nLen:=Len(aSerT)
      IF nLen>1
         aSers:=Array(nLen+1)
         aSers[1]:="<Todas las series>"
         FOR nI=1 TO nLen
            aSers[nI+1]:=aSerT[nI,1]
         NEXT nI
      ELSE
         aSers:=Array(1)
         aSers[1]:=aSerT[1,1]
      ENDIF
      nLen:=Len(aPerT)
      aPers:=Array(nLen)
      FOR nI=1 TO nLen
         aPers[nI]:=aPerT[nI]
      NEXT nI
      IF nGraph=SERIE_VALUES
         aItem:=AClone(aSers)
      ELSE
         aItem:=AClone(aPers)
      ENDIF

      oGraph:aSTemp :=AClone(aSerT)
      oGraph:aSeries:=AClone(aSerT)
      oGraph:aYTemp :=AClone(aPerT)
      oGraph:aDTemp :=AClone(aDatT)
      oGraph:aYVals :=AClone(aPerT)
      oGraph:aData  :=AClone(aDatT)
      oCbx:SetItems(aItem)
      cItem:=aItem[1]
      oCbx:Select(1)
      oCbx:Refresh()

   ENDIF

RETURN (NIL)

static FUNC Chg_Fonts(oDlg,nRow,nCol,oGraph)
   LOCAL oMenu, aFont, oFont, nOpt:=0
   LOCAL nTClr :=oGraph:nClrT
   LOCAL nXClr :=oGraph:nClrX
   LOCAL nYClr :=oGraph:nClrY
   LOCAL nLClr :=oGraph:nClrL
   LOCAL nSClr :=oGraph:nClrST
   LOCAL nXTClr:=oGraph:nClrXT
   LOCAL nYTClr:=oGraph:nClrYT
   LOCAL nVClr :=oGraph:nClrV
   MENU oMenu POPUP
      MENUITEM "&Ttulo     " ACTION oGraph:aFont[1]:Choose(@nTClr )
      MENUITEM "&Valores    " ACTION oGraph:aFont[2]:Choose(@nXClr )
      MENUITEM "&Etiquetas  " ACTION oGraph:aFont[3]:Choose(@nYClr )
      MENUITEM "&Leyendas   " ACTION oGraph:aFont[4]:Choose(@nLClr )
      MENUITEM "&Subttulo  " ACTION oGraph:aFont[5]:Choose(@nSClr )
      MENUITEM "&Ttulo en X" ACTION oGraph:aFont[6]:Choose(@nXTClr)
      MENUITEM "&Ttulo en Y" ACTION oGraph:aFont[7]:Choose(@nYTClr)
      MENUITEM "&Valores    " ACTION oGraph:aFont[8]:Choose(@nVClr )
   ENDMENU
   ACTIVATE POPUP oMenu OF oDlg AT nRow,nCol

   oGraph:nClrT :=nTClr
   oGraph:nClrX :=nXClr
   oGraph:nClrY :=nYClr
   oGraph:nClrL :=nLClr
   oGraph:nClrST:=nSClr
   oGraph:nClrXT:=nXTClr
   oGraph:nClrYT:=nYTClr
   oGraph:nClrV :=nVClr

   oGraph:Refresh()
RETURN (NIL)

static FUNC SelColors(oBtn,nColor)        // Seleccin de colores
   nColor:=ChooseColor(nColor)
   oBtn:SetBrush(TBrush():New(,nColor))
   oBtn:Refresh()
RETURN (nColor)

static FUNC aGetSeries(oGraph)            // Arreglo de series
   LOCAL nI, aRet :={}
   FOR nI:=1 TO Len(oGraph:aSTemp)
       AAdd(aRet,oGraph:aSTemp[nI][1])
   NEXT nI
RETURN (aRet)

static FUNC GetName(oLbx,oSer,cSerie,aSerL,lNew,aSerT,aPerT,aDatT)
   LOCAL oDld, cName, nColor, oBtn, nOpt, nLen, aTemp
   LOCAL lReg:=.F., cTitle, nSer, nI
   nOpt:=oSer:nAt
   IF lNew
      cName:=Space(25)
      nColor:=CLR_RED
      cTitle:="Nueva serie"
   ELSE
      cName:=aSerT[nOpt][1]+Space(25-Len(aSerT[nOpt][1]))
      nColor:=aSerT[nOpt][2]
      cTitle:="Cambio de atributos"
   ENDIF
   DEFINE DIALOG oDld RESOURCE "GetSerie" FONT oWnd:oFont TITLE cTitle
   REDEFINE GET cName ID 101 OF oDld PICTURE "@X" VALID !Empty(cName)
   REDEFINE BTNBMP oBtn ID 102 OF oDld TOOLTIP "Seleccionar..."     ;
      ACTION nColor:=SelColors(oBtn,nColor)
   REDEFINE BUTTON ID 110 OF oDld ACTION (lReg:=.T.,oDld:End())
   REDEFINE BUTTON ID 120 OF oDld ACTION (lReg:=.F.,oDld:End()) CANCEL
   oBtn:nClrPane:=nColor
   ACTIVATE DIALOG oDld
   IF lReg
      cSerie:=cName
      IF lNew
         aTemp:={cName,nColor}
         AAdd(aSerT,aTemp)
         nLen:=Len(aDatT[1])
         aTemp:=Array(nLen)
         AFill(aTemp,0)
         AAdd(aDatT,aTemp)
         oSer:Add(cName)
         nSer:=AScan(aSerL,cName)
         oSer:Select(nSer)
         oSer:Refresh()
         SysRefresh()
         GetValues(oLbx,oSer,aSerT,aDatT,aPerT)
      ELSE
         aSerT[nOpt][1]:=cName
         aSerT[nOpt][2]:=nColor
         aSerL[nOpt]:=cName
         nSer:=AScan(aSerL,cName)
         oSer:Modify(cName,nSer)
         oSer:Refresh()
      ENDIF
   ENDIF
   oLbx:SetFocus()
RETURN (NIL)

static FUNC DelSerie(oSer,cSerie,aSerL,aSerT,aPerT,aDatT)
   LOCAL nOpt:=oSer:nAt, aTemp, nI, nLen, cName, nSer
   IF Len(aSerL)=1
      MsgAlert("No puede borrar la nica serie del grfico.","Precaucin")
   ELSE
      cName:=aSerL[nOpt-1]
      aDel(aSerL,nOpt)
      ASize(aSerL,Len(aSerL)-1)
      aDel(aSerT,nOpt)
      ASize(aSerT,Len(aSerT)-1)
      aDel(aDatT,nOpt)
      ASize(aDatT,Len(aDatT)-1)
      nSer:=AScan(aSerL,cName)
      oSer:SetItems(aSerL)
      oSer:Select(nSer)
      oSer:Refresh()
   ENDIF
RETURN (NIL)

static FUNC GetValues(oLbx,oSer,aSerT,aDatT,aPerT)    // Carga de valores
   LOCAL nI, nLen, lPer, nSerie:=Max(oSer:nAt,1)
   lPer:=IF(Len(aPerT)!=0,.T.,.F.)
   nLen   :=Len(aDatT[nSerie])
   aValues:=Array(nLen,3)
   nTotal:=0
   FOR nI:=1 TO nLen
      IF lPer
         aValues[nI][1]:=aPerT[nI]
      ELSE
         aValues[nI][1]:=Tran(nI,"9999")
      ENDIF
      aValues[nI][2]:=aDatT[nSerie][nI]
      nTotal+=aValues[nI][2]
      aValues[nI][3]:=.F.
   NEXT nI
   oLbx:SetArray(aValues)
   oLbx:GoTop()
   oLbx:Refresh()
   oLbx:SetFocus()
RETURN (NIL)

static FUNC ValnKey(nKey,oLbx,oB,nSer,aSerT,aDatT,aPerT)   // Control del browse
   DO CASE
      CASE nKey==VK_INSERT
         KeyToggle(VK_INSERT)
         NewPeriod(oLbx,oB,nSer,aSerT,aDatT,aPerT)
      CASE nKey==VK_DELETE
         DelPeriod(oLbx,nSer,aSerT,aDatT,aPerT)
      CASE nKey==VK_RETURN
         ChgPeriod(oLbx,oB,nSer,aSerT,aDatT,aPerT)
   ENDCASE
RETURN (NIL)

static FUNC EditValue(oLbx,nCol,cBuffer,aValues,lFirst)
   LOCAL aTemp , nAt:=oLbx:nAt, uBuffer, lContinue:=.T.
   LOCAL bValid, nColReal:=nCol
   nCol--
   uBuffer:=aValues[nAt,nCol]
   DO WHILE .T.
      DO CASE
         CASE nCol == 1  // Periodo
            IF lContinue:=oLbx:lEditCol(nColReal,@uBuffer,"@X",,CLR_WHITE,CLR_BLUE)
               aValues[nAt,1] := uBuffer
            ENDIF
         CASE nCol == 2  // Valor
            IF lContinue:=oLbx:lEditCol(nColReal,@uBuffer,"@ZE 9999,999.99",,CLR_WHITE,CLR_BLUE)
               aValues[nAt,2] := uBuffer
               aValues[nAt,3] := .F.
               lContinue:=.F.
            EndIf
      ENDCASE
      IF !lContinue .AND. aValues[nAt,3]
         DelPeriod(oLbx)
         RETURN .F.
      ENDIF
      EXIT
   ENDDO
   SumValues(oLbx)
   IF lContinue
      DO CASE
         CASE oLbx:nLastKey == VK_UP
            RETURN IF(!GetKeyState(VK_SHIFT),-3,-2)
         CASE oLbx:nLastKey == VK_DOWN
            RETURN IF(!GetKeyState(VK_SHIFT), 3, 2)
         CASE oLbx:nLastKey == VK_TAB
            RETURN IF( GetKeyState(VK_SHIFT),-1, 1)
      ENDCASE
   ENDIF
RETURN (lContinue)

static FUNC NewPeriod(oLbx,oB,nSer,aSerT,aDatT,aPerT)
   LOCAL nI, nLen
   FOR nI=4 TO 6
      oB[nI]:Disable()
      oB[nI]:Refresh()
   NEXT nI
   nLen:=Len(aValues)
   AAdd(aValues,{Space(10),0,.T.})
   oLbx:Refresh()
   oLbx:lHitBottom:=.F.
   oLbx:GoBottom()
   oLbx:Edit()
   IF Len(aValues)>nLen
      AAdd(aPerT,aValues[oLbx:nAt][1])
      FOR nI=1 TO Len(aSerT)
         AAdd(aDatT[nI],0)
      NEXT nI
      aDatT[nSer][oLbx:nAt]:=aValues[oLbx:nAt][2]
   ENDIF
   FOR nI=4 TO 6
      oB[nI]:Enable()
      oB[nI]:Refresh()
   NEXT nI
RETURN (Nil)

static FUNC DelPeriod(oLbx,nSer,aSerT,aDatT,aPerT)
   LOCAL nI
   DEFAULT nSer:=0
   IF Len(aValues)=1
      MsgAlert("No puede borrar el nico periodo de la serie.","Precaucin")
   ELSE
      IF nSer<>0
         ADel(aPerT,oLbx:nAt)
         ASize(aPerT,Len(aPerT)-1)
         FOR nI=1 TO Len(aSerT)
            ADel(aDatT[nI],oLbx:nAt)
            ASize(aDatT[nI],Len(aDatT[nI])-1)
         NEXT nI
      ENDIF
      ADel(aValues,oLbx:nAt)
      ASize(aValues,Len(aValues)-1)
      oLbx:GoUp()
      SumValues(oLbx)
   ENDIF
RETURN (Nil)

static FUNC ChgPeriod(oLbx,oB,nSer,aSerT,aDatT,aPerT)
   LOCAL nI
   FOR nI=4 TO 6
      oB[nI]:Disable()
      oB[nI]:Refresh()
   NEXT nI
   aValues[oLbx:nAt,1]+=Space(10-Len(aValues[oLbx:nAt,1]))
   oLbx:Edit()
   aDatT[nSer][oLbx:nAt]:=aValues[oLbx:nAt][2]
   aPerT[oLbx:nAt]:=aValues[oLbx:nAt][1]
   FOR nI=4 TO 6
      oB[nI]:Enable()
      oB[nI]:Refresh()
   NEXT nI
RETURN (Nil)

static FUNC SumValues(oLbx)
   nTotal:= 0
   AEval(aValues,{|aItem| nTotal+=aItem[2]})
   oLbx:Refresh()
RETURN (Nil)

// --- Abrir y Guardar Valores del Grfico (Gracias a Jorge Dreher)

static FUNC LoadGraph(cFile,oGraph,aItem,cItem,oCbx)
   LOCAL oIni, nLen, aDat[50], nI, nP, nX, nColor, nItem
   LOCAL cName, nWidth, nHeight, lBold, lItalic, lUnderLine
   IF Empty(cFile)
      #ifdef __CLIPPER__
         cFile:=cGetFile32("Grficas|*.TGr","Seleccione archivo")
      #else
         cFile:=cGetFile("Grficas|*.TGr","Seleccione archivo")
      #endif
   ENDIF
   IF File(cFile)
      CursorWait()
      INI oIni FILE cFile
         oGraph:nClrPane:=uValue(GetPvProfString("View","nClrPane","",cFile))
         oGraph:nClrBack:=uValue(GetPvProfString("View","nClrBack","",cFile))
         oGraph:nClrGrid:=uValue(GetPvProfString("View","nClrGrid","",cFile))
         GET oGraph:nType      SECTION "View"   ENTRY "nType"     OF oIni DEFAULT  1
         GET oGraph:l3D        SECTION "View"   ENTRY "l3D"       OF oIni DEFAULT .T.
         GET oGraph:lTitle     SECTION "View"   ENTRY "lTitle"    OF oIni DEFAULT .T.
         GET oGraph:lyVal      SECTION "View"   ENTRY "lyVal"     OF oIni DEFAULT .T.
         GET oGraph:lxVal      SECTION "View"   ENTRY "lxVal"     OF oIni DEFAULT .T.
         GET oGraph:lLegends   SECTION "View"   ENTRY "lLegends"  OF oIni DEFAULT .T.
         GET oGraph:lViewVal   SECTION "View"   ENTRY "lViewVal"  OF oIni DEFAULT .F.
         GET oGraph:lxGrid     SECTION "View"   ENTRY "lxGrid"    OF oIni DEFAULT .T.
         GET oGraph:lyGrid     SECTION "View"   ENTRY "lyGrid"    OF oIni DEFAULT .T.
         GET oGraph:lBorders   SECTION "View"   ENTRY "lBorders"  OF oIni DEFAULT .F.
         GET oGraph:lcTitle    SECTION "View"   ENTRY "lcTitle"   OF oIni DEFAULT .T.
         GET oGraph:nBarD      SECTION "View"   ENTRY "nBarD"     OF oIni DEFAULT 15
         GET oGraph:nXRanges   SECTION "View"   ENTRY "nXRanges"  OF oIni DEFAULT  4
         GET oGraph:nBarSep    SECTION "View"   ENTRY "nBarSep"   OF oIni DEFAULT  3
         GET oGraph:nValues    SECTION "View"   ENTRY "nValues"   OF oIni DEFAULT 1
         GET oGraph:nPenWidth  SECTION "View"   ENTRY "nPenWidth" OF oIni DEFAULT 1
         GET oGraph:nPieSt     SECTION "View"   ENTRY "nPieSt"    OF oIni DEFAULT 1
         GET oGraph:nPoint     SECTION "View"   ENTRY "nPoint"    OF oIni DEFAULT 2
         GET oGraph:cBitmap    SECTION "View"   ENTRY "cBitmap"   OF oIni DEFAULT ''
         GET nGraph            SECTION "View"   ENTRY "nGraph"    OF oIni DEFAULT 1
         GET cItem             SECTION "View"   ENTRY "cItem"     OF oIni DEFAULT ''

         GET oGraph:cTitle     SECTION "Titles" ENTRY "cTitle"    OF oIni DEFAULT ''
         GET oGraph:cSubTit    SECTION "Titles" ENTRY "cSubTit"   OF oIni DEFAULT ''
         GET oGraph:cTitX      SECTION "Titles" ENTRY "cTitX"     OF oIni DEFAULT ''
         GET oGraph:cTitY      SECTION "Titles" ENTRY "cTitY"     OF oIni DEFAULT ''
         GET oGraph:aSTitle[1] SECTION "Titles" ENTRY "lSTi1"     OF oIni DEFAULT .T.
         GET oGraph:aSTitle[2] SECTION "Titles" ENTRY "lSTi2"     OF oIni DEFAULT .T.
         GET oGraph:aSTitle[3] SECTION "Titles" ENTRY "lSTi3"     OF oIni DEFAULT .T.
         GET oGraph:aSTitle[4] SECTION "Titles" ENTRY "lSTi4"     OF oIni DEFAULT .T.
         GET oGraph:cPicture   SECTION "Titles" ENTRY "cPicture"  OF oIni DEFAULT "999,999.99"

         GET nColor      SECTION "Colors" ENTRY "nClrT"     OF oIni DEFAULT CLR_BLACK
         oGraph:nClrT   :=uValue(nColor)
         GET nColor      SECTION "Colors" ENTRY "nClrX"     OF oIni DEFAULT CLR_BLACK
         oGraph:nClrX   :=uValue(nColor)
         GET nColor      SECTION "Colors" ENTRY "nClrY"     OF oIni DEFAULT CLR_BLACK
         oGraph:nClrY   :=uValue(nColor)
         GET nColor      SECTION "Colors" ENTRY "nClrL"     OF oIni DEFAULT CLR_BLACK
         oGraph:nClrL   :=uValue(nColor)
         GET nColor      SECTION "Colors" ENTRY "nClrV"     OF oIni DEFAULT CLR_BLACK
         oGraph:nClrV   :=uValue(nColor)
         GET nColor     SECTION "Colors"  ENTRY "nClrST"    OF oIni DEFAULT CLR_BLACK
         oGraph:nClrST  :=uValue(nColor)
         GET nColor     SECTION "Colors"  ENTRY "nClrXT"    OF oIni DEFAULT CLR_BLACK
         oGraph:nClrXT  :=uValue(nColor)
         GET nColor     SECTION "Colors"  ENTRY "nClrYT"    OF oIni DEFAULT CLR_BLACK
         oGraph:nClrYT  :=uValue(nColor)

         oGraph:aSeries:={}
         oGraph:aSTemp :={}
         oGraph:aData  :={}
         oGraph:aDTemp :={}
         oGraph:aYVals :={}
         oGraph:aYTemp :={}
         GET nLen SECTION "Series" ENTRY "Lenght" OF oIni
         nLen:=uValue(nLen)
         oGraph:aSeries:=Array(nLen)
         aSers:=Array(nLen+1)
         aSers[1]:="<Todas las series>"
         FOR nI=1 TO nLen
            GET nX SECTION "Series"+lTrim(Str(nI)) ENTRY "Lenght" OF oIni
            oGraph:aSeries[nI]:=Array(2)
            GET oGraph:aSeries[nI,1] SECTION "Series"+lTrim(Str(nI)) ENTRY "Value1" OF oIni
            GET oGraph:aSeries[nI,2] SECTION "Series"+lTrim(Str(nI)) ENTRY "Value2" OF oIni
            oGraph:aSeries[nI,2]:=uValue(oGraph:aSeries[nI,2])
            aSers[nI+1]:=oGraph:aSeries[nI,1]
         NEXT nI
         oGraph:aSTemp:=AClone(oGraph:aSeries)
         IF nLen=1
            ADel(aSers,1)
            ASize(aSers,Len(aSers)-1)
         ENDIF

         GET nLen SECTION "Data"   ENTRY "Lenght" OF oIni
         nLen:=uValue(nLen)
         oGraph:aData  :=Array(nLen)
         FOR nI=1 TO nLen
             GET nX SECTION "Data"  +lTrim(Str(nI)) ENTRY "Lenght" OF oIni
             nX:=uValue(nX)
             oGraph:aData[nI]  :=Array(nX)
             FOR nP=1 TO nX
                GET oGraph:aData[nI,nP]   SECTION "Data"  +lTrim(Str(nI)) ENTRY "Value"+lTrim(Str(nP)) OF oIni
                oGraph:aData[nI,nP]  :=uValue(oGraph:aData[nI,nP])
             NEXT nP
         NEXT nI
         oGraph:aDTemp:=AClone(oGraph:aData)

         aPers:={}
         GET nLen SECTION "YVals"  ENTRY "Lenght" OF oIni
         nLen:=uValue(nLen)
         IF nLen>0
            oGraph:aYVals:=Array(nLen)
            aPers:=Array(nLen)
            FOR nI=1 TO nLen
               GET oGraph:aYVals[nI] SECTION "YVals" ENTRY "Value"+lTrim(Str(nI)) OF oIni
            NEXT nI
         ENDIF
         oGraph:aYTemp:=AClone(oGraph:aYVals)
         aPers :=AClone(oGraph:aYVals)
         nGraph:=uValue(nGraph)
         IF nGraph=SERIE_VALUES
            aItem:=AClone(aSers)
         ELSE
            aItem:=AClone(aPers)
         ENDIF

         FOR nI=1 TO 8
            oGraph:aFont[nI]:End()
         NEXT nI

         GET cName      SECTION "Font_T" ENTRY "Name"      OF oIni DEFAULT "Arial"
         GET nHeight    SECTION "Font_T" ENTRY "Height"    OF oIni DEFAULT -15
         GET lBold      SECTION "Font_T" ENTRY "Bold"      OF oIni DEFAULT .T.
         GET lItalic    SECTION "Font_T" ENTRY "Italic"    OF oIni DEFAULT .F.
         GET lUnderLine SECTION "Font_T" ENTRY "UnderLine" OF oIni DEFAULT .F.
         oGraph:aFont[1]:=TFont():New(cName,0,-uValue(nHeight),.F.,;
                                      uLogic(lBold),,,,uLogic(lItalic),uLogic(lUnderline))

         GET cName      SECTION "Font_X" ENTRY "Name"      OF oIni DEFAULT "Arial"
         GET nHeight    SECTION "Font_X" ENTRY "Height"    OF oIni DEFAULT -10
         GET lBold      SECTION "Font_X" ENTRY "Bold"      OF oIni DEFAULT .F.
         GET lItalic    SECTION "Font_X" ENTRY "Italic"    OF oIni DEFAULT .F.
         GET lUnderLine SECTION "Font_X" ENTRY "UnderLine" OF oIni DEFAULT .F.
         oGraph:aFont[2]:=TFont():New(cName,0,-uValue(nHeight),.F.,;
                                      uLogic(lBold),,,,uLogic(lItalic),uLogic(lUnderline))

         GET cName      SECTION "Font_Y" ENTRY "Name"      OF oIni DEFAULT "Arial"
         GET nHeight    SECTION "Font_Y" ENTRY "Height"    OF oIni DEFAULT -10
         GET lBold      SECTION "Font_Y" ENTRY "Bold"      OF oIni DEFAULT .F.
         GET lItalic    SECTION "Font_Y" ENTRY "Italic"    OF oIni DEFAULT .F.
         GET lUnderLine SECTION "Font_Y" ENTRY "UnderLine" OF oIni DEFAULT .F.
         oGraph:aFont[3]:=TFont():New(cName,0,-uValue(nHeight),.F.,;
                                      uLogic(lBold),,,,uLogic(lItalic),uLogic(lUnderline))

         GET cName      SECTION "Font_L" ENTRY "Name"      OF oIni DEFAULT "Arial"
         GET nHeight    SECTION "Font_L" ENTRY "Height"    OF oIni DEFAULT -10
         GET lBold      SECTION "Font_L" ENTRY "Bold"      OF oIni DEFAULT .F.
         GET lItalic    SECTION "Font_L" ENTRY "Italic"    OF oIni DEFAULT .F.
         GET lUnderLine SECTION "Font_L" ENTRY "UnderLine" OF oIni DEFAULT .F.
         oGraph:aFont[4]:=TFont():New(cName,0,-uValue(nHeight),.F.,;
                                      uLogic(lBold),,,,uLogic(lItalic),uLogic(lUnderline))

         GET cName      SECTION "Font_S" ENTRY "Name"      OF oIni DEFAULT "Arial"
         GET nHeight    SECTION "Font_S" ENTRY "Height"    OF oIni DEFAULT -10
         GET lBold      SECTION "Font_S" ENTRY "Bold"      OF oIni DEFAULT .F.
         GET lItalic    SECTION "Font_S" ENTRY "Italic"    OF oIni DEFAULT .F.
         GET lUnderLine SECTION "Font_S" ENTRY "UnderLine" OF oIni DEFAULT .F.
         oGraph:aFont[5]:=TFont():New(cName,0,-uValue(nHeight),.F.,;
                                      uLogic(lBold),,,,uLogic(lItalic),uLogic(lUnderline))

         GET cName      SECTION "FontXT" ENTRY "Name"      OF oIni DEFAULT "Arial"
         GET nHeight    SECTION "FontXT" ENTRY "Height"    OF oIni DEFAULT -10
         GET lBold      SECTION "FontXT" ENTRY "Bold"      OF oIni DEFAULT .T.
         GET lItalic    SECTION "FontXT" ENTRY "Italic"    OF oIni DEFAULT .F.
         GET lUnderLine SECTION "FontXT" ENTRY "UnderLine" OF oIni DEFAULT .F.
         oGraph:aFont[6]:=TFont():New(cName,0,-uValue(nHeight),.F.,;
                                      uLogic(lBold),898,,,uLogic(lItalic),uLogic(lUnderline))

         GET cName      SECTION "FontYT" ENTRY "Name"      OF oIni DEFAULT "Arial"
         GET nHeight    SECTION "FontYT" ENTRY "Height"    OF oIni DEFAULT -10
         GET lBold      SECTION "FontYT" ENTRY "Bold"      OF oIni DEFAULT .T.
         GET lItalic    SECTION "FontYT" ENTRY "Italic"    OF oIni DEFAULT .F.
         GET lUnderLine SECTION "FontYT" ENTRY "UnderLine" OF oIni DEFAULT .F.
         oGraph:aFont[7]:=TFont():New(cName,0,-uValue(nHeight),.F.,;
                                      uLogic(lBold),,,,uLogic(lItalic),uLogic(lUnderline))

         GET cName      SECTION "Font_V" ENTRY "Name"      OF oIni DEFAULT "Arial"
         GET nHeight    SECTION "Font_V" ENTRY "Height"    OF oIni DEFAULT -10
         GET lBold      SECTION "Font_V" ENTRY "Bold"      OF oIni DEFAULT .F.
         GET lItalic    SECTION "Font_V" ENTRY "Italic"    OF oIni DEFAULT .F.
         GET lUnderLine SECTION "Font_V" ENTRY "UnderLine" OF oIni DEFAULT .F.
         oGraph:aFont[8]:=TFont():New(cName,0,-uValue(nHeight),.F.,;
                                      uLogic(lBold),,,,uLogic(lItalic),uLogic(lUnderline))

      ENDINI
      nGraph:=uValue(nGraph)
      nItem:=AScan(aItem,cItem)
      Sel_Graph(aItem,aItem,oGraph,oCbx,cItem,nItem)
      IF nItem>1
         oCbx:Select(nItem)
         oCbx:Refresh()
         View_Graph(oCbx,oGraph)
      ENDIF
      CursorArrow()
   ENDIF
RETURN (NIL)

static FUNC uValue(n)
   LOCAL nRet:=0
   IF ValType(n)="N"
      nRet:=n
   ELSEIF ValType(n)="C"
      IF Val(n)=0 .AND. !("0"$lTrim(n))
         nRet:=0
      ELSE
         nRet:=Val(n)
      ENDIF
   ENDIF
RETURN (nRet)

static FUNC uLogic(u)
   LOCAL lRet:=.F.
   IF ValType(u)="L"
      lRet:=u
   ELSEIF ValType(u)="C"
      IF u$"T"
         lRet:=.T.
      ENDIF
   ENDIF
RETURN (lRet)

FUNCTION SaveGraph(oGraph,cItem,cFile)
   LOCAL nI, nP, oDld, oIni, lReg:=.T., nOpt:=1
   IF Empty(cFile)
      lReg:=.F.
      cFile:="Grafica "
      DEFINE DIALOG oDld RESOURCE "GetFile" FONT oWnd:oFont
      REDEFINE GET cFile ID 100 OF oDld PICTURE "@X" VALID !Empty(cFile)
      REDEFINE RADIO nOpt ID 101,102 OF oDld
      REDEFINE BUTTON ID 110 OF oDld ACTION (lReg:=.T.,oDld:End())
      REDEFINE BUTTON ID 120 OF oDld ACTION (lReg:=.F.,oDld:End())
      ACTIVATE DIALOG oDld
   ENDIF
   IF lReg
      CursorWait()
//    cFile:=Alltrim(cFile)+".TGr"
//    IF File(cFile)
//       ERASE (cFile)
//    ENDIF
      INI oIni FILE ".\"+Alltrim(cFile)+".TGr"
         SET SECTION "View"   ENTRY "nClrPane"  OF oIni TO oGraph:nClrPane
         SET SECTION "View"   ENTRY "nClrBack"  OF oIni TO oGraph:nClrBack
         SET SECTION "View"   ENTRY "nClrGrid"  OF oIni TO oGraph:nClrGrid
         SET SECTION "View"   ENTRY "nType"     OF oIni TO oGraph:nType
         SET SECTION "View"   ENTRY "l3D"       OF oIni TO oGraph:l3D
         SET SECTION "View"   ENTRY "lTitle"    OF oIni TO oGraph:lTitle
         SET SECTION "View"   ENTRY "lyVal"     OF oIni TO oGraph:lyVal
         SET SECTION "View"   ENTRY "lxVal"     OF oIni TO oGraph:lxVal
         SET SECTION "View"   ENTRY "lLegends"  OF oIni TO oGraph:lLegends
         SET SECTION "View"   ENTRY "lViewVal"  OF oIni TO oGraph:lViewVal
         SET SECTION "View"   ENTRY "lxGrid"    OF oIni TO oGraph:lxGrid
         SET SECTION "View"   ENTRY "lyGrid"    OF oIni TO oGraph:lyGrid
         SET SECTION "View"   ENTRY "lBorders"  OF oIni TO oGraph:lBorders
         SET SECTION "View"   ENTRY "lcTitle"   OF oIni TO oGraph:lcTitle
         SET SECTION "View"   ENTRY "nBarD"     OF oIni TO oGraph:nBarD
         SET SECTION "View"   ENTRY "nXRanges"  OF oIni TO oGraph:nXRanges
         SET SECTION "View"   ENTRY "nBarSep"   OF oIni TO oGraph:nBarSep
         SET SECTION "View"   ENTRY "nValues"   OF oIni TO oGraph:nValues
         SET SECTION "View"   ENTRY "nPenWidth" OF oIni TO oGraph:nPenWidth
         SET SECTION "View"   ENTRY "nPieSt"    OF oIni TO oGraph:nPieSt
         SET SECTION "View"   ENTRY "nPoint"    OF oIni TO oGraph:nPoint
         SET SECTION "View"   ENTRY "cBitmap"   OF oIni TO oGraph:cBitmap
         SET SECTION "View"   ENTRY "nGraph"    OF oIni TO nGraph
         SET SECTION "View"   ENTRY "cItem"     OF oIni TO cItem

         SET SECTION "Titles" ENTRY "cTitle"    OF oIni TO oGraph:cTitle
         SET SECTION "Titles" ENTRY "cSubTit"   OF oIni TO oGraph:cSubTit
         SET SECTION "Titles" ENTRY "cTitX"     OF oIni TO oGraph:cTitX
         SET SECTION "Titles" ENTRY "cTitY"     OF oIni TO oGraph:cTitY
         SET SECTION "Titles" ENTRY "lSTi1"     OF oIni TO oGraph:aSTitle[1]
         SET SECTION "Titles" ENTRY "lSTi2"     OF oIni TO oGraph:aSTitle[2]
         SET SECTION "Titles" ENTRY "lSTi3"     OF oIni TO oGraph:aSTitle[3]
         SET SECTION "Titles" ENTRY "lSTi4"     OF oIni TO oGraph:aSTitle[4]
         SET SECTION "Titles" ENTRY "cPicture"  OF oIni TO oGraph:cPicture

         SET SECTION "Colors" ENTRY "nClrT"     OF oIni TO oGraph:nClrT
         SET SECTION "Colors" ENTRY "nClrX"     OF oIni TO oGraph:nClrX
         SET SECTION "Colors" ENTRY "nClrY"     OF oIni TO oGraph:nClrY
         SET SECTION "Colors" ENTRY "nClrL"     OF oIni TO oGraph:nClrL
         SET SECTION "Colors" ENTRY "nClrV"     OF oIni TO oGraph:nClrV
         SET SECTION "Colors" ENTRY "nClrST"    OF oIni TO oGraph:nClrST
         SET SECTION "Colors" ENTRY "nClrXT"    OF oIni TO oGraph:nClrXT
         SET SECTION "Colors" ENTRY "nClrYT"    OF oIni TO oGraph:nClrYT

         IF nOpt=1
            SET SECTION "Series" ENTRY "Lenght"  OF oIni TO Len(oGraph:aSTemp)
            FOR nI=1 TO Len(oGraph:aSTemp)
               SET SECTION "Series"+lTrim(Str(nI)) ENTRY "Lenght" OF oIni TO Len(oGraph:aSTemp[nI])
               FOR nP=1 TO Len(oGraph:aSTemp[nI])
                  SET SECTION "Series"+lTrim(Str(nI)) ENTRY "Value"+lTrim(Str(nP)) OF oIni TO oGraph:aSTemp[nI,nP]
               NEXT nP
            NEXT nI

            SET SECTION "Data" ENTRY "Lenght"   OF oIni TO Len(oGraph:aDTemp)
            FOR nI=1 TO Len(oGraph:aDTemp)
               SET SECTION "Data"+lTrim(Str(nI))  ENTRY "Lenght"  OF oIni TO Len(oGraph:aDTemp[nI])
               FOR nP=1 TO Len(oGraph:aDTemp[nI])
                  SET SECTION "Data"+lTrim(Str(nI)) ENTRY "Value"+lTrim(Str(nP)) OF oIni TO oGraph:aDTemp[nI,nP]
               NEXT nP
            NEXT nI

            SET SECTION "YVals" ENTRY "Lenght"   OF oIni TO Len(oGraph:aYTemp)
            FOR nI=1 TO Len(oGraph:aYTemp)
               SET SECTION "YVals" ENTRY "Value"+lTrim(Str(nI)) OF oIni TO oGraph:aYTemp[nI]
            NEXT nI
         ENDIF

         IF nOpt=2
            SET SECTION "Series" ENTRY "Lenght"  OF oIni TO Len(oGraph:aSeries)
            FOR nI=1 TO Len(oGraph:aSeries)
               SET SECTION "Series"+lTrim(Str(nI)) ENTRY "Lenght" OF oIni TO Len(oGraph:aSeries[nI])
               FOR nP=1 TO Len(oGraph:aSeries[nI])
                  SET SECTION "Series"+lTrim(Str(nI)) ENTRY "Value"+lTrim(Str(nP)) OF oIni TO oGraph:aSeries[nI,nP]
               NEXT nP
            NEXT nI

            SET SECTION "Data" ENTRY "Lenght"   OF oIni TO Len(oGraph:aData)
            FOR nI=1 TO Len(oGraph:aData)
               SET SECTION "Data"+lTrim(Str(nI))  ENTRY "Lenght"  OF oIni TO Len(oGraph:aData[nI])
               FOR nP=1 TO Len(oGraph:aData[nI])
                  SET SECTION "Data"+lTrim(Str(nI)) ENTRY "Value"+lTrim(Str(nP)) OF oIni TO oGraph:aData[nI,nP]
               NEXT nP
            NEXT nI

            SET SECTION "YVals" ENTRY "Lenght"   OF oIni TO Len(oGraph:aYVals)
            FOR nI=1 TO Len(oGraph:aYVals)
               SET SECTION "YVals" ENTRY "Value"+lTrim(Str(nI)) OF oIni TO oGraph:aYVals[nI]
            NEXT nI
         ENDIF

         SET SECTION "Font_T" ENTRY "Name"      OF oIni TO oGraph:aFont[1]:cFaceName
         SET SECTION "Font_T" ENTRY "Height"    OF oIni TO oGraph:aFont[1]:nHeight
         SET SECTION "Font_T" ENTRY "Bold"      OF oIni TO oGraph:aFont[1]:lBold
         SET SECTION "Font_T" ENTRY "Italic"    OF oIni TO oGraph:aFont[1]:lItalic
         SET SECTION "Font_T" ENTRY "UnderLine" OF oIni TO oGraph:aFont[1]:lUnderLine

         SET SECTION "Font_X" ENTRY "Name"      OF oIni TO oGraph:aFont[2]:cFaceName
         SET SECTION "Font_X" ENTRY "Height"    OF oIni TO oGraph:aFont[2]:nHeight
         SET SECTION "Font_X" ENTRY "Bold"      OF oIni TO oGraph:aFont[2]:lBold
         SET SECTION "Font_X" ENTRY "Italic"    OF oIni TO oGraph:aFont[2]:lItalic
         SET SECTION "Font_X" ENTRY "UnderLine" OF oIni TO oGraph:aFont[2]:lUnderLine

         SET SECTION "Font_Y" ENTRY "Name"      OF oIni TO oGraph:aFont[3]:cFaceName
         SET SECTION "Font_Y" ENTRY "Height"    OF oIni TO oGraph:aFont[3]:nHeight
         SET SECTION "Font_Y" ENTRY "Bold"      OF oIni TO oGraph:aFont[3]:lBold
         SET SECTION "Font_Y" ENTRY "Italic"    OF oIni TO oGraph:aFont[3]:lItalic
         SET SECTION "Font_Y" ENTRY "UnderLine" OF oIni TO oGraph:aFont[3]:lUnderLine

         SET SECTION "Font_L" ENTRY "Name"      OF oIni TO oGraph:aFont[4]:cFaceName
         SET SECTION "Font_L" ENTRY "Height"    OF oIni TO oGraph:aFont[4]:nHeight
         SET SECTION "Font_L" ENTRY "Bold"      OF oIni TO oGraph:aFont[4]:lBold
         SET SECTION "Font_L" ENTRY "Italic"    OF oIni TO oGraph:aFont[4]:lItalic
         SET SECTION "Font_L" ENTRY "UnderLine" OF oIni TO oGraph:aFont[4]:lUnderLine

         SET SECTION "Font_S" ENTRY "Name"      OF oIni TO oGraph:aFont[5]:cFaceName
         SET SECTION "Font_S" ENTRY "Height"    OF oIni TO oGraph:aFont[5]:nHeight
         SET SECTION "Font_S" ENTRY "Bold"      OF oIni TO oGraph:aFont[5]:lBold
         SET SECTION "Font_S" ENTRY "Italic"    OF oIni TO oGraph:aFont[5]:lItalic
         SET SECTION "Font_S" ENTRY "UnderLine" OF oIni TO oGraph:aFont[5]:lUnderLine

         SET SECTION "FontXT" ENTRY "Name"      OF oIni TO oGraph:aFont[6]:cFaceName
         SET SECTION "FontXT" ENTRY "Height"    OF oIni TO oGraph:aFont[6]:nHeight
         SET SECTION "FontXT" ENTRY "Bold"      OF oIni TO oGraph:aFont[6]:lBold
         SET SECTION "FontXT" ENTRY "Italic"    OF oIni TO oGraph:aFont[6]:lItalic
         SET SECTION "FontXT" ENTRY "UnderLine" OF oIni TO oGraph:aFont[6]:lUnderLine

         SET SECTION "FontYT" ENTRY "Name"      OF oIni TO oGraph:aFont[7]:cFaceName
         SET SECTION "FontYT" ENTRY "Height"    OF oIni TO oGraph:aFont[7]:nHeight
         SET SECTION "FontYT" ENTRY "Bold"      OF oIni TO oGraph:aFont[7]:lBold
         SET SECTION "FontYT" ENTRY "Italic"    OF oIni TO oGraph:aFont[7]:lItalic
         SET SECTION "FontYT" ENTRY "UnderLine" OF oIni TO oGraph:aFont[7]:lUnderLine

         SET SECTION "Font_V" ENTRY "Name"      OF oIni TO oGraph:aFont[8]:cFaceName
         SET SECTION "Font_V" ENTRY "Height"    OF oIni TO oGraph:aFont[8]:nHeight
         SET SECTION "Font_V" ENTRY "Bold"      OF oIni TO oGraph:aFont[8]:lBold
         SET SECTION "Font_V" ENTRY "Italic"    OF oIni TO oGraph:aFont[8]:lItalic
         SET SECTION "Font_V" ENTRY "UnderLine" OF oIni TO oGraph:aFont[8]:lUnderLine

      ENDINI
      CursorArrow()
   ENDIF
RETURN (NIL)

// --- To printer

FUNCTION GetPrtCoors(oGraph)
   LOCAL oDlg, oFont,  ;
         nTop   := 2.5,;
         nLeft  := 2.5,;
         nHeight:= 4.5,;
         nWidth := 9.5
   DEFINE FONT oFont NAME "MS Sans Serif" SIZE 0,-10
   DEFINE DIALOG oDlg FROM 15,45 TO  21.5,73.5 TITLE "Imprimir" FONT oFont
   @   7, 8  SAY "Superior"   SIZE 25,10 PIXEL
   @  17, 8  SAY "Izquierda"  SIZE 25,10 PIXEL
   @  27, 8  SAY "Largo"      SIZE 25,10 PIXEL
   @  37, 8  SAY "Alto"         SIZE 25,10 PIXEL
   @   7,75  SAY "(en cm)"    SIZE 25,10 PIXEL
   @   6,35  GET nTop         PICTURE "99.99" SIZE 20,9 PIXEL
   @  16,35  GET nLeft        PICTURE "99.99" SIZE 20,9 PIXEL
   @  26,35  GET nWidth       PICTURE "99.99" SIZE 20,9 PIXEL
   @  36,35  GET nHeight      PICTURE "99.99" SIZE 20,9 PIXEL
   @  20,65 BUTTON "&Acepta"  SIZE 40,10 PIXEL OF oDlg ACTION (oDlg:End(),Print(oGraph,nTop,nLeft,nWidth,nHeight))
   @  35,65 BUTTON "&Cancela" SIZE 40,10 PIXEL OF oDlg ACTION oDlg:End()
   ACTIVATE DIALOG oDlg
   oFont:End()
RETURN (NIL)

FUNCTION Print(oGraph, nTop, nLeft, nWidth, nHeight)
   LOCAL oPrn
   PRINT oPrn NAME "Impresin de grficos" PREVIEW
      oPrn:Cmtr2Pix(@nTop  , @nLeft)
      oPrn:Cmtr2Pix(@nWidth, @nHeight)
      PAGE
         oGraph:Print( oPrn, nTop, nLeft, nWidth, nHeight )
      ENDPAGE
   ENDPRINT
RETURN (NIL)

procedure AppSys  // Xbase++ requirement

return
